/*********************************************************************
 * popproxy version 1.02  19/2/97 by N.Oren                          *
 * used to convert long user names to unix user names and connect to *
 * the appropriate mail hub.                                         *
 * Need to do:                                                       *
 * more error checking                                               *
 *********************************************************************/

#include "hash.h"
#include "buffer.h"
#ifdef SPARC
#include <crypt.h>
#endif
#include <ctype.h>
#include <signal.h>
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <pwd.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <sys/socket.h>
#include <sys/stat.h>
#include <netinet/in.h>
#include <time.h>
#include <fcntl.h>
#include <unistd.h>
#include <netdb.h>
#include <syslog.h>
#include <gdbm.h>
#define LISTENON 110   
/*what port to listen for conns on*/
#define HUBPORT 110		
/*what port mail hub listens on*/
#define DEFFILE "./poprc"
/*# of seconds till timeout when  waiting for data*/
#define TIMEOUT 120                     
/*Uncomment the following if passwords are stored encrypted, this way it
will look for both encrypted and unencrypted passwds */
#define ENCRYPT
/*uncomment if you want to use the unix database stuff,highly recomended*/
#define GDBM

#ifndef GDBM
node db;  /*root of hash table*/
#endif

sockbuf instream,mailhub;
struct popinfo
{
  char fullname[100];
  char accntname[10];
  char mailhub[100];
  char pwd[15];
};
/*SIGNAL HANDLERS:*/
void timeout(int signal);
void child_handle(int signal);

void makehash(void); /*Make hash table*/
int getinfo(char *username, popinfo *info);/*get info from hash table*/
int validate(popinfo &userinfo);/*validate username*/
int connecttohost(popinfo userinfo);/*connect to mail hub*/
int handle(int sock);/*handle a connection*/
